'use strict';

exports.__esModule = true;
exports.default = undefined;

var _browserEssentials = require('browser-essentials');

var _emitterExtended = require('emitter-extended');

var _emitterExtended2 = _interopRequireDefault(_emitterExtended);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HashHistory = function (_Emitter) {
  _inherits(HashHistory, _Emitter);

  function HashHistory(history_) {
    _classCallCheck(this, HashHistory);

    var _this = _possibleConstructorReturn(this, _Emitter.call(this, 'HashHistory'));

    _this.location = _browserEssentials.url.fromHash();

    _this.register('navigate', 'routerUpdated');
    _this._hashChangeListener = _this.handleHashChange.bind(_this);
    window.addEventListener('hashchange', _this._hashChangeListener);
    _this.on('navigate', _this.handleNavigate.bind(_this));
    return _this;
  }

  HashHistory.prototype.onRouterUpdate = function onRouterUpdate(fn) {
    return this.on('routerUpdated', fn);
  };

  HashHistory.prototype.handleHashChange = function handleHashChange(e) {
    if (e.newURL !== e.oldURL) {
      this.emit('navigate', _browserEssentials.url.fromHash());
    }
  };

  HashHistory.prototype.handleNavigate = function handleNavigate() {
    this.location = _browserEssentials.url.fromHash();
  };

  HashHistory.prototype.goto = function goto(url_) {
    var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    window.location.hash = '#' + _browserEssentials.url.parse(url_).path;
  };

  HashHistory.prototype.toObject = function toObject() {
    var out = {};

    for (var key in context.historyContext) {
      out[key] = this[key];
    }

    return out;
  };

  HashHistory.prototype.dispose = function dispose() {
    this.removeAllListeners();
    window.removeEventListener('hashchange', this._hashChangeListener);
  };

  return HashHistory;
}(_emitterExtended2.default);

exports.default = HashHistory;