'use strict';

exports.__esModule = true;
exports.default = undefined;

var _browserEssentials = require('browser-essentials');

var _emitterExtended = require('emitter-extended');

var _emitterExtended2 = _interopRequireDefault(_emitterExtended);

var _context = require('./context');

var context = _interopRequireWildcard(_context);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Html5History = function (_Emitter) {
  _inherits(Html5History, _Emitter);

  function Html5History(history_) {
    _classCallCheck(this, Html5History);

    var _this = _possibleConstructorReturn(this, _Emitter.call(this, 'Html5History'));

    _this.location = _browserEssentials.url.fromWindow();

    _this.history = history_ || window.history || history;
    _this.register('navigate', 'routerUpdated');
    _this._popStateListener = _this.handlePopState.bind(_this);
    window.addEventListener('popstate', _this._popStateListener);
    _this.on('navigate', _this.handleNavigate.bind(_this));
    return _this;
  }

  Html5History.prototype.onRouterUpdate = function onRouterUpdate(fn) {
    return this.on('routerUpdated', fn);
  };

  Html5History.prototype.handlePopState = function handlePopState() {
    this.emit('navigate', _browserEssentials.url.fromWindow());
  };

  Html5History.prototype.handleNavigate = function handleNavigate() {
    this.location = _browserEssentials.url.fromWindow();
  };

  Html5History.prototype.push = function push() {
    var _history;

    (_history = this.history).pushState.apply(_history, arguments);
  };

  Html5History.prototype.get = function get() {
    return this.history.state;
  };

  Html5History.prototype.back = function back() {
    this.history.go(-1);
  };

  Html5History.prototype.forward = function forward() {
    this.history.go(1);
  };

  // This needs to be updated to match the API of goto or a new method
  // needs to be added


  Html5History.prototype.replace = function replace() {
    var _history2;

    (_history2 = this.history).replaceState.apply(_history2, arguments);
  };

  Html5History.prototype.goto = function goto(url_) {
    var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    var parsed = _browserEssentials.url.parse(url_);

    if (parsed.href !== this.location.href) {
      this.push(state, title, url_);
    }

    this.emit('navigate', parsed);
  };

  Html5History.prototype.toObject = function toObject() {
    var out = {};

    for (var key in context.historyContext) {
      out[key] = this[key];
    }

    return out;
  };

  Html5History.prototype.dispose = function dispose() {
    this.removeAllListeners();
    window.removeEventListener('popstate', this._popStateListener);
  };

  return Html5History;
}(_emitterExtended2.default);

exports.default = Html5History;