'use strict';

exports.__esModule = true;
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _trimStart = require('lodash/trimStart');

var _trimStart2 = _interopRequireDefault(_trimStart);

var _browserEssentials = require('browser-essentials');

var _context = require('./context');

var context = _interopRequireWildcard(_context);

var _urlFor = require('./urlFor');

var _urlFor2 = _interopRequireDefault(_urlFor);

var _routeParser = require('./routeParser');

var routeParser = _interopRequireWildcard(_routeParser);

var _getPathForRouteNamed = require('./getPathForRouteNamed');

var _getPathForRouteNamed2 = _interopRequireDefault(_getPathForRouteNamed);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isActive = function isActive(href, location) {
  return _browserEssentials.url.resolve(location.href, href) === location.href;
};

var extendHref = function extendHref(path, opts) {
  path = _browserEssentials.url.parse(path);

  if (opts.query) {
    path = path.filter(opts.query);
  }

  if (opts.hash && opts.hash.length) {
    path.hash = '#' + (0, _trimStart2.default)(opts.hash, '#');
  }

  return _browserEssentials.url.format(path);
};

var extractHref = function extractHref(context, props) {
  var hrefObj = props.for || props.to;
  var wasString = typeof hrefObj === 'string';
  var href = hrefObj;
  var hrefKey = null;

  if (!wasString) {
    if (hrefObj.displayName === void 0) {
      // Not a react object
      hrefKey = Object.keys(hrefObj)[0];
      href = hrefKey;
    } else {
      href = hrefObj.displayName;
      wasString = true;
    }
  }

  if (props.for) {
    href = (0, _urlFor2.default)(context.router.routes, href, props, props.assertValidFormat);
  }

  if (!wasString) {
    href = extendHref(href, hrefObj[hrefKey]);
  }

  return href;
};

var Link = (_temp2 = _class = function (_React$Component) {
  _inherits(Link, _React$Component);

  function Link() {
    var _temp, _this, _ret;

    _classCallCheck(this, Link);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      href: null,
      isActive: false
    }, _this._routerListener = null, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Link.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
  };

  Link.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    this._routerListener = this.context.router.onUpdate(function (location) {
      var active = isActive(_this2.state.href, location);

      if (active !== _this2.state.isActive) {
        _this2.setState({ isActive: active });
      }
    });

    this.updateIfActiveChange(this.props, true);
  };

  Link.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this._routerListener !== void 0) {
      this._routerListener.off();
    }
  };

  Link.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.updateIfActiveChange(nextProps);
  };

  Link.prototype.updateIfActiveChange = function updateIfActiveChange(nextProps, forceUpdate) {
    if (!(0, _shallowequal2.default)(this.props, nextProps) || forceUpdate) {
      var href = extractHref(this.context, nextProps);
      var active = isActive(href, this.context.router.location);

      if (active !== this.state.isActive || href !== this.state.href) {
        this.setState({ isActive: active, href: href });
      }
    }
  };

  Link.prototype.click = function click() {
    this.context.router.goto(this.state.href);
  };

  Link.prototype.render = function render() {
    return _react2.default.createElement('a', this.renderProps);
  };

  _createClass(Link, [{
    key: 'className',
    get: function get() {
      var cname = [];

      if (this.props.className) {
        cname.push(this.props.className);
      }

      if (this.state.href && this.props.activeClassName && this.state.isActive) {
        cname.push(this.props.activeClassName);
      }

      return cname.join(' ') || null;
    }
  }, {
    key: 'renderProps',
    get: function get() {
      var props = Object.assign({}, this.props);
      props.href = this.state.href;
      props.className = this.className;

      // Remove default props
      for (var prop in Link.defaultProps) {
        delete props[prop];
      }

      // Remove url keys
      if (this.props.for !== null) {
        var forPath = void 0;

        if (typeof this.props.for !== 'string') {
          if (this.props.for.displayName !== void 0) {
            forPath = this.props.for.displayName;
          } else {
            forPath = Object.keys(this.props.for)[0];
          }
        } else {
          forPath = this.props.for;
        }

        forPath = (0, _getPathForRouteNamed2.default)(this.context.router.routes, forPath);
        var parsedPath = [];

        try {
          parsedPath = routeParser.parse(forPath);
        } catch (e) {}

        for (var _iterator = parsedPath, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref2 = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref2 = _i.value;
          }

          var _ref = _ref2;
          var lit = _ref[0];
          var _prop = _ref[1];
          var rule = _ref[2];

          delete props[_prop];
        }
      }

      return props;
    }
  }]);

  return Link;
}(_react2.default.Component), _class.displayName = 'Link', _class.contextTypes = context.contextShape, _class.defaultProps = {
  to: null,
  for: null,
  activeClassName: 'active',
  assertValidFormat: false
}, _temp2);
exports.default = Link;