'use strict';

exports.__esModule = true;
exports.contextShape = exports.historyContext = exports.historyShape = exports.routeContext = exports.routeShape = exports.routerContext = exports.routerShape = undefined;

var _react = require('react');

var routerShape = exports.routerShape = {
  routes: _react.PropTypes.object.isRequired,
  location: _react.PropTypes.object.isRequired,
  goto: _react.PropTypes.func.isRequired,
  back: _react.PropTypes.func,
  forward: _react.PropTypes.func,
  replace: _react.PropTypes.func,
  on: _react.PropTypes.func,
  off: _react.PropTypes.func,
  onUpdate: _react.PropTypes.func
};

var routerContext = exports.routerContext = {
  routes: null,
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  on: null,
  off: null,
  onUpdate: null
};

var routeShape = exports.routeShape = {
  path: _react.PropTypes.string,
  params: _react.PropTypes.object
};

var routeContext = exports.routeContext = {
  path: null,
  params: null
};

var historyShape = exports.historyShape = {
  location: _react.PropTypes.object.isRequired,
  goto: _react.PropTypes.func,
  back: _react.PropTypes.func,
  forward: _react.PropTypes.func,
  replace: _react.PropTypes.func,
  push: _react.PropTypes.func,
  get: _react.PropTypes.func,
  on: _react.PropTypes.func,
  off: _react.PropTypes.func,
  onRouterUpdate: _react.PropTypes.func
};

var historyContext = exports.historyContext = {
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  push: null,
  get: null,
  on: null,
  off: null,
  onRouterUpdate: null
};

var contextShape = exports.contextShape = {
  router: _react.PropTypes.object,
  route: _react.PropTypes.object
};