'use strict';

exports.__esModule = true;

var _routeIsNamed = require('./routeIsNamed');

var _routeIsNamed2 = _interopRequireDefault(_routeIsNamed);

var _routeIsNamedLike = require('./routeIsNamedLike');

var _routeIsNamedLike2 = _interopRequireDefault(_routeIsNamedLike);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _cache = new WeakMap();
var _getCache = function _getCache(routes) {
  if (_cache.has(routes)) {
    return _cache.get(routes);
  }

  var c = {};
  _cache.set(routes, c);

  return c;
};

var _get = function _get(routes, name) {
  var outPath = void 0;
  var matches = [];

  for (var _iterator = routes.entries(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    var _ref2;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref2 = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref2 = _i.value;
    }

    var _ref = _ref2;
    var path = _ref[0];
    var route = _ref[1];

    // Either the absolute route name is matched or the route.name is matched
    if ((0, _routeIsNamed2.default)(route, name)) {
      outPath = path;
    }

    // Partial matches
    if ((0, _routeIsNamedLike2.default)(route, name)) {
      matches.push(path);
    }
  }

  if (outPath === void 0 && matches.length) {
    outPath = matches[0];
  }

  return outPath;
};

exports.default = function (routes, name) {
  var cache = _getCache(routes);

  var getter = function getter() {
    if (cache.hasOwnProperty(name)) {
      return cache[name];
    }

    cache[name] = _get(routes, name);
    return cache[name];
  };

  return getter();
};