var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { url } from 'browser-essentials';
import Emitter from 'emitter-extended';

var HashHistory = function (_Emitter) {
  _inherits(HashHistory, _Emitter);

  function HashHistory(history_) {
    _classCallCheck(this, HashHistory);

    var _this = _possibleConstructorReturn(this, (HashHistory.__proto__ || Object.getPrototypeOf(HashHistory)).call(this, 'HashHistory'));

    _this.location = url.fromHash();

    _this.register('navigate', 'routerUpdated');
    _this._hashChangeListener = _this.handleHashChange.bind(_this);
    window.addEventListener('hashchange', _this._hashChangeListener);
    _this.on('navigate', _this.handleNavigate.bind(_this));
    return _this;
  }

  _createClass(HashHistory, [{
    key: 'onRouterUpdate',
    value: function onRouterUpdate(fn) {
      return this.on('routerUpdated', fn);
    }
  }, {
    key: 'handleHashChange',
    value: function handleHashChange(e) {
      if (e.newURL !== e.oldURL) {
        this.emit('navigate', url.fromHash());
      }
    }
  }, {
    key: 'handleNavigate',
    value: function handleNavigate() {
      this.location = url.fromHash();
    }
  }, {
    key: 'goto',
    value: function goto(url_) {
      var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      window.location.hash = '#' + url.parse(url_).path;
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      var out = {};

      for (var key in context.historyContext) {
        out[key] = this[key];
      }

      return out;
    }
  }, {
    key: 'dispose',
    value: function dispose() {
      this.removeAllListeners();
      window.removeEventListener('hashchange', this._hashChangeListener);
    }
  }]);

  return HashHistory;
}(Emitter);

export { HashHistory as default };