var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { url } from 'browser-essentials';
import Emitter from 'emitter-extended';
import * as context from './context';

var Html5History = function (_Emitter) {
  _inherits(Html5History, _Emitter);

  function Html5History(history_) {
    _classCallCheck(this, Html5History);

    var _this = _possibleConstructorReturn(this, (Html5History.__proto__ || Object.getPrototypeOf(Html5History)).call(this, 'Html5History'));

    _this.location = url.fromWindow();

    _this.history = history_ || window.history || history;
    _this.register('navigate', 'routerUpdated');
    _this._popStateListener = _this.handlePopState.bind(_this);
    window.addEventListener('popstate', _this._popStateListener);
    _this.on('navigate', _this.handleNavigate.bind(_this));
    return _this;
  }

  _createClass(Html5History, [{
    key: 'onRouterUpdate',
    value: function onRouterUpdate(fn) {
      return this.on('routerUpdated', fn);
    }
  }, {
    key: 'handlePopState',
    value: function handlePopState() {
      this.emit('navigate', url.fromWindow());
    }
  }, {
    key: 'handleNavigate',
    value: function handleNavigate() {
      this.location = url.fromWindow();
    }
  }, {
    key: 'push',
    value: function push() {
      var _history;

      (_history = this.history).pushState.apply(_history, arguments);
    }
  }, {
    key: 'get',
    value: function get() {
      return this.history.state;
    }
  }, {
    key: 'back',
    value: function back() {
      this.history.go(-1);
    }
  }, {
    key: 'forward',
    value: function forward() {
      this.history.go(1);
    }

    // This needs to be updated to match the API of goto or a new method
    // needs to be added

  }, {
    key: 'replace',
    value: function replace() {
      var _history2;

      (_history2 = this.history).replaceState.apply(_history2, arguments);
    }
  }, {
    key: 'goto',
    value: function goto(url_) {
      var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      var parsed = url.parse(url_);

      if (parsed.href !== this.location.href) {
        this.push(state, title, url_);
      }

      this.emit('navigate', parsed);
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      var out = {};

      for (var key in context.historyContext) {
        out[key] = this[key];
      }

      return out;
    }
  }, {
    key: 'dispose',
    value: function dispose() {
      this.removeAllListeners();
      window.removeEventListener('popstate', this._popStateListener);
    }
  }]);

  return Html5History;
}(Emitter);

export { Html5History as default };