var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import shallowCompare from 'react-addons-shallow-compare';
import shallowEqual from 'shallowequal';
import trimStart from 'lodash/trimStart';
import { url } from 'browser-essentials';
import * as context from './context';
import urlFor from './urlFor';
import * as routeParser from './routeParser';
import getPathForRouteNamed from './getPathForRouteNamed';

var isActive = function isActive(href, location) {
  return url.resolve(location.href, href) === location.href;
};

var extendHref = function extendHref(path, opts) {
  path = url.parse(path);

  if (opts.query) {
    path = path.filter(opts.query);
  }

  if (opts.hash && opts.hash.length) {
    path.hash = '#' + trimStart(opts.hash, '#');
  }

  return url.format(path);
};

var extractHref = function extractHref(context, props) {
  var hrefObj = props.for || props.to;
  var wasString = typeof hrefObj === 'string';
  var href = hrefObj;
  var hrefKey = null;

  if (!wasString) {
    if (hrefObj.displayName === void 0) {
      // Not a react object
      hrefKey = Object.keys(hrefObj)[0];
      href = hrefKey;
    } else {
      href = hrefObj.displayName;
      wasString = true;
    }
  }

  if (props.for) {
    href = urlFor(context.router.routes, href, props, props.assertValidFormat);
  }

  if (!wasString) {
    href = extendHref(href, hrefObj[hrefKey]);
  }

  return href;
};

var Link = (_temp2 = _class = function (_React$Component) {
  _inherits(Link, _React$Component);

  function Link() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Link);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Link.__proto__ || Object.getPrototypeOf(Link)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      href: null,
      isActive: false
    }, _this._routerListener = null, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Link, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return shallowCompare(this, nextProps, nextState);
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      this._routerListener = this.context.router.onUpdate(function (location) {
        var active = isActive(_this2.state.href, location);

        if (active !== _this2.state.isActive) {
          _this2.setState({ isActive: active });
        }
      });

      this.updateIfActiveChange(this.props, true);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this._routerListener !== void 0) {
        this._routerListener.off();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.updateIfActiveChange(nextProps);
    }
  }, {
    key: 'updateIfActiveChange',
    value: function updateIfActiveChange(nextProps, forceUpdate) {
      if (!shallowEqual(this.props, nextProps) || forceUpdate) {
        var href = extractHref(this.context, nextProps);
        var active = isActive(href, this.context.router.location);

        if (active !== this.state.isActive || href !== this.state.href) {
          this.setState({ isActive: active, href: href });
        }
      }
    }
  }, {
    key: 'click',
    value: function click() {
      this.context.router.goto(this.state.href);
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement('a', this.renderProps);
    }
  }, {
    key: 'className',
    get: function get() {
      var cname = [];

      if (this.props.className) {
        cname.push(this.props.className);
      }

      if (this.state.href && this.props.activeClassName && this.state.isActive) {
        cname.push(this.props.activeClassName);
      }

      return cname.join(' ') || null;
    }
  }, {
    key: 'renderProps',
    get: function get() {
      var props = Object.assign({}, this.props);
      props.href = this.state.href;
      props.className = this.className;

      // Remove default props
      for (var prop in Link.defaultProps) {
        delete props[prop];
      }

      // Remove url keys
      if (this.props.for !== null) {
        var forPath = void 0;

        if (typeof this.props.for !== 'string') {
          if (this.props.for.displayName !== void 0) {
            forPath = this.props.for.displayName;
          } else {
            forPath = Object.keys(this.props.for)[0];
          }
        } else {
          forPath = this.props.for;
        }

        forPath = getPathForRouteNamed(this.context.router.routes, forPath);
        var parsedPath = [];

        try {
          parsedPath = routeParser.parse(forPath);
        } catch (e) {}

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = parsedPath[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _ref2 = _step.value;

            var _ref3 = _slicedToArray(_ref2, 3);

            var lit = _ref3[0];
            var _prop = _ref3[1];
            var rule = _ref3[2];

            delete props[_prop];
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      return props;
    }
  }]);

  return Link;
}(React.Component), _class.displayName = 'Link', _class.contextTypes = context.contextShape, _class.defaultProps = {
  to: null,
  for: null,
  activeClassName: 'active',
  assertValidFormat: false
}, _temp2);
export { Link as default };