var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { dom, url } from 'browser-essentials';
import { setDefinedOpt } from 'opt-setter';
import * as routeMatcher from './routeMatcher';
import Html5History from './Html5History';
import RouterContext from './RouterContext';

var Router = (_temp2 = _class = function (_React$Component) {
  _inherits(Router, _React$Component);

  function Router() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Router);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Router.__proto__ || Object.getPrototypeOf(Router)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      location: null,
      route: { path: null, params: {}, view: null },
      routes: new Map()
    }, _this._listeners = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Router, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var location = this.props.initialLocation || this.props.history.location;
      var routes = routeMatcher.findRoutes(this.props.children);
      var route = this.getRoute(routes, location);

      this.setState({ location: location, routes: routes, route: route });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var gotoListener = this.handleGoto.bind(this);
      this.props.history.on('navigate', gotoListener);

      var clickListener = this.handleClick.bind(this);
      document.addEventListener('click', clickListener);

      this._listeners.push(gotoListener, clickListener);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _listeners = _slicedToArray(this._listeners, 2),
          gotoListener = _listeners[0],
          clickListener = _listeners[1];

      this.props.history.dispose();
      document.removeEventListener('click', clickListener);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.props.history.emit('routerUpdated', this.props.history.location);
    }
  }, {
    key: 'handleGoto',
    value: function handleGoto(location) {
      var route = this.getRoute(this.state.routes, location);
      this.setState({ location: location, route: route });
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      // Ignores middle, ctrl, cmd and shift clicks
      if (dom.isMetaClick(e)) {
        return;
      }

      // Only targets A tags
      var target = e.target.nodeName === 'A' ? e.target : dom.findParentNode(e.target, 'A', this.props.maxClickSearchDepth);

      if (target === void 0) return;

      // Ignores links with a `ignore` or `data-ignore` attribute
      if (dom.hasAttr(target, 'ignore') || target.hasAttribute('target') || dom.hasAttr(target, 'href') === false) {
        return;
      }

      // Only continues if there is an `href` or `data-href` attribute present
      e.preventDefault();

      var href = dom.getAttr(target, 'href') || dom.getAttr(target, 'url');
      var location = url.resolve(this.state.location.href, href);

      // Tells the history handler to go to the new location
      this.props.history.goto(location);
    }
  }, {
    key: 'getContextProps',
    value: function getContextProps() {
      var contextProps = Object.assign({}, this.state, Router.defaultProps);

      setDefinedOpt(contextProps, this.props, false);
      contextProps.router = this;
      delete contextProps.maxClickSearchDepth;

      return contextProps;
    }
  }, {
    key: 'getRoute',
    value: function getRoute() {
      var routes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.routes;
      var location = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.state.location;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = routes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref2 = _step.value;

          var _ref3 = _slicedToArray(_ref2, 2);

          var path = _ref3[0];
          var route = _ref3[1];

          var match = routeMatcher.match(path, location.path);

          if (match !== void 0) {
            var _match = _slicedToArray(match, 2),
                _path = _match[0],
                params = _match[1];

            var view = route.view;
            /*
            console.log('Matched path:', path,
                        '\nMatched params:', params,
                        '\nMatched view:', view)
            */
            return { path: _path, params: params, view: view };
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      throw new Error('Route not found for location: ' + ('' + this.state.location.href));
    }
  }, {
    key: '_getViewPropsFrom',
    value: function _getViewPropsFrom(props) {
      var viewProps = Object.assign({}, props);

      delete viewProps.routes;
      delete viewProps.location;

      return viewProps;
    }
  }, {
    key: 'render',
    value: function render() {
      var App = this.props.app;
      var props = this.getContextProps();
      var View = null;
      var viewProps = this._getViewPropsFrom(props);

      if (this.state.route.view) {
        View = this.state.route.view;
      }

      return React.createElement(
        RouterContext,
        props,
        React.createElement(
          App,
          viewProps,
          React.createElement(View, viewProps)
        )
      );
    }
  }]);

  return Router;
}(React.Component), _class.displayName = 'Router', _class.defaultProps = {
  history: new Html5History(),
  initialLocation: null,
  maxClickSearchDepth: 10
}, _temp2);
export { Router as default };