import { PropTypes } from 'react';

export var routerShape = {
  routes: PropTypes.object.isRequired,
  location: PropTypes.object.isRequired,
  goto: PropTypes.func.isRequired,
  back: PropTypes.func,
  forward: PropTypes.func,
  replace: PropTypes.func,
  on: PropTypes.func,
  off: PropTypes.func,
  onUpdate: PropTypes.func
};

export var routerContext = {
  routes: null,
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  on: null,
  off: null,
  onUpdate: null
};

export var routeShape = {
  path: PropTypes.string,
  params: PropTypes.object
};

export var routeContext = {
  path: null,
  params: null
};

export var historyShape = {
  location: PropTypes.object.isRequired,
  goto: PropTypes.func,
  back: PropTypes.func,
  forward: PropTypes.func,
  replace: PropTypes.func,
  push: PropTypes.func,
  get: PropTypes.func,
  on: PropTypes.func,
  off: PropTypes.func,
  onRouterUpdate: PropTypes.func
};

export var historyContext = {
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  push: null,
  get: null,
  on: null,
  off: null,
  onRouterUpdate: null
};

export var contextShape = {
  router: PropTypes.object,
  route: PropTypes.object
};