var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

import routeIsNamed from './routeIsNamed';
import routeIsNamedLike from './routeIsNamedLike';

var _cache = new WeakMap();
var _getCache = function _getCache(routes) {
  if (_cache.has(routes)) {
    return _cache.get(routes);
  }

  var c = {};
  _cache.set(routes, c);

  return c;
};

var _get = function _get(routes, name) {
  var outPath = void 0;
  var matches = [];

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = routes.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ref = _step.value;

      var _ref2 = _slicedToArray(_ref, 2);

      var path = _ref2[0];
      var route = _ref2[1];

      // Either the absolute route name is matched or the route.name is matched
      if (routeIsNamed(route, name)) {
        outPath = path;
      }

      // Partial matches
      if (routeIsNamedLike(route, name)) {
        matches.push(path);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  if (outPath === void 0 && matches.length) {
    outPath = matches[0];
  }

  return outPath;
};

export default (function (routes, name) {
  var cache = _getCache(routes);

  var getter = function getter() {
    if (cache.hasOwnProperty(name)) {
      return cache[name];
    }

    cache[name] = _get(routes, name);
    return cache[name];
  };

  return getter();
});