import {PropTypes} from 'react'


export const routerShape = {
  routes: PropTypes.object.isRequired,
  location: PropTypes.object.isRequired,
  goto: PropTypes.func.isRequired,
  back: PropTypes.func,
  forward: PropTypes.func,
  replace: PropTypes.func,
  on: PropTypes.func,
  off: PropTypes.func,
  onUpdate: PropTypes.func
}


export const routerContext = {
  routes: null,
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  on: null,
  off: null,
  onUpdate: null
}


export const routeShape = {
  path: PropTypes.string,
  params: PropTypes.object,
}


export const routeContext = {
  path: null,
  params: null
}


export const historyShape = {
  location: PropTypes.object.isRequired,
  goto: PropTypes.func,
  back: PropTypes.func,
  forward: PropTypes.func,
  replace: PropTypes.func,
  push: PropTypes.func,
  get: PropTypes.func,
  on: PropTypes.func,
  off: PropTypes.func,
  onRouterUpdate: PropTypes.func
}


export const historyContext = {
  location: null,
  goto: null,
  back: null,
  forward: null,
  replace: null,
  push: null,
  get: null,
  on: null,
  off: null,
  onRouterUpdate: null
}


export const contextShape = {
  router: PropTypes.object,
  route: PropTypes.object
}
