import getRouteName from './getRouteName'


export default (component, schemes) => {
  let view = component.props.view

  if (view === void 0) {
    for (let scheme of schemes) {
      if (scheme.props.view) {
        view = scheme.props.view
      }
    }
  }

  if (view !== void 0) {
    return view
  }

  const routeName = component.props.name || component.props.path ||
                    getRouteName(component)
                    
  throw new Error(`View not found for route: ${routeName}`)
}
