// /test/the/rest/{for:.*})}/yes?{test:best}=chest&creep={fish:focker}&tester=bester
// /test/best/{all}/{}/day?={}
{
  /** Helper functions
   **/
  const trim = str => {
    const left = str.slice(0, 1) === '('
    const right = str.slice(-1) === ')'
    
    if (left && right) {
      return str.slice(1, -1)
    }

    return str
  }
}


start
  = route


/** Constants
 **/
_ 'whitespace'
  = [ \t\r\n]*

NUM 'number'
  = [0-9]

ALPHA 'alpha character'
  = [a-z]i

ALNUM 'alphanumeric character'
  = alnums:(ALPHA / NUM) {
    return alnums;
  }

HEXDIG 'hexadecimal character'
  = [0-9a-f]i


/** Route constants
 **/
NAME_START
  = _'{'_

NAME_END
  = _'}'_

REGEX_SEP
  = _':'_

ESCAPE
  = '\\'

REGEX_UNESCAPED
  = [^\0\x1F\x7d]

REGEX
  =   REGEX_UNESCAPED
    / ESCAPE
    seq: (
        ESCAPE
      / '}'
      / '/'
      / 'u' digits:$(HEXDIG HEXDIG HEXDIG HEXDIG) {
           return String.fromCharCode(parseInt(digits, 16))
          }) {
      return seq
    }


/** Route grammar
 **/
route
  = path: path?
    query: query? {
      return {path, query}
    }

path
  = segs: (segs:pathSegment* {return segs}) {
      return segs
    }

pathSegment
  = group: (namedGroup / (path: [^?{]+ {return path.join('')})) {
      return group
    }

query
  = value: queryParam* {
      return value.filter((v) => v.name !== null ? v : null)
    }

queryParam
  = [&?] name: queryGroup?
    [=]* value: queryGroup? {
      return {name, value}
    }

queryGroup
   = group: (NAME_START groupName:ALNUM* REGEX_SEP* regex:REGEX* NAME_END {
             return {
               name: groupName ? groupName && groupName.join('') : null,
               regex: regex && regex.length ? `(${trim(regex.join(''))})` : null
             }})?
     query: ([^&=]+)? {
       return group !== null ? group : (query ? query.join('') : '')
     }

namedGroup
   = NAME_START groupName:ALNUM* REGEX_SEP* regex:REGEX* NAME_END {
       return {
         name: groupName ? groupName && groupName.join('') : null,
         regex: regex && regex.length ? `(${trim(regex.join(''))})` : null
       }
     }
